#
#  tktextframe.rb
#                       2000/04/22  Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
# ƥȤɽ뤿Υե졼 (ĲΥСդ)
# TkComposite ⥸塼ˤʤäƤޤ
#
#require 'tk'

class TextFrame<TkText
  include TkComposite

  # Composite widget ν
  #
  # TkComposite ⥸塼ѤˤϡåȤ֤Τᡤ
  # initialize_composite ᥽åɤƤɬפޤ
  # Υ᥽åɤƤФǤϡȤʤե졼Ƥꡤ
  # 󥹥ѿ @frame ǻȤ뤳ȤǤޤ
  # 륦åȤϤΥե졼ξ֤ޤ
  # Ȥʤե졼Υåȥѥϡ󥹥ѿ @epath ˤ
  # ꤵƤ뤿ᡤpack ᥽åɤθƤӽФϡȤʤե졼Ф
  # ʤޤ
  # 
  def initialize_composite(keys={})
    # Τʣ
    keys = keys.dup

    # СåȤ
    @v_scroll = TkScrollbar.new(@frame, 'orient'=>'vertical')
    @h_scroll = TkScrollbar.new(@frame, 'orient'=>'horizontal')

    # ƥȥåȤ
    @text = TkText.new(@frame, 'wrap'=>'none')

    # CompositeåȤΥ᥽åɸƤӽФդ٤
    # åȤΥѥTkΥåȥѥˤꤹ롣
    @path = @text.path

    # 륳ޥɤ
    @text.xscrollcommand proc{|first, last| @h_scroll.set first, last}
    @text.yscrollcommand proc{|first, last| @v_scroll.set first, last}
    @v_scroll.command proc{|args| @text.yview *args}
    @h_scroll.command proc{|args| @text.xview *args}

    # grid ȥޥ͡ѤƳƥåȤ
    TkGrid.rowconfigure(@frame, 0, 'weight'=>1, 'minsize'=>0)
    TkGrid.columnconfigure(@frame, 0, 'weight'=>1, 'minsize'=>0)
    @text.grid('row'=>0, 'column'=>0, 'sticky'=>'news')

    # Сɽ̵ͭϥ᥽åɤѤ
    vscroll(keys.delete('vscroll'){true})
    hscroll(keys.delete('hscroll'){true})

    # ƥطʿˤ᥽åɤѤ
    color = keys.delete('textbackground')
    textbackground(color) if color

    # °᥽åɸƤӽФ٤åȤ
    delegate('DEFAULT', @text)
    delegate('background', @frame, @h_scroll, @v_scroll)
    delegate('activebackground', @h_scroll, @v_scroll)
    delegate('troughcolor', @h_scroll, @v_scroll)
    delegate('repeatdelay', @h_scroll, @v_scroll)
    delegate('repeatinterval', @h_scroll, @v_scroll)
    delegate('borderwidth', @frame)
    delegate('relief', @frame)

    # °μ»
    configure keys unless keys.empty?
  end

  # ƥطʿ
  def textbackground(color)
    @text.background(color)
  end

  # ĥС ON, OFF
  def vscroll(mode)
    st = TkGrid.info(@v_scroll)  # ֺѤߤǧ (̤֤ʤ [])
    if mode && st == [] then
      @v_scroll.grid('row'=>0, 'column'=>1, 'sticky'=>'ns')
    elsif !mode && st != [] then
      @v_scroll.ungrid
    end
    self
  end

  # С ON, OFF
  def hscroll(mode, wrap_mode="char")
    st = TkGrid.info(@h_scroll)  # ֺѤߤǧ (̤֤ʤ [])
    if mode && st == [] then
      @h_scroll.grid('row'=>1, 'column'=>0, 'sticky'=>'ew')
      wrap 'none'  # => self.wrap('none')
    elsif !mode && st != [] then
      @h_scroll.ungrid
      wrap wrap_mode  # => self.wrap(wrap_mode)
    end
    self
  end
end
